From 56e588e807e801ef677278e2f17bf295f14ed2b0 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Pavel=20B=C5=99ezina?= <pbrezina@redhat.com>
Date: Tue, 14 May 2013 15:00:05 +0200
Subject: [PATCH 4/4] providers: refresh expired netgroups

https://fedorahosted.org/sssd/ticket/1713
---
 Makefile.am                       |   1 +
 src/providers/ad/ad_init.c        |  10 +++
 src/providers/ipa/ipa_init.c      |  10 +++
 src/providers/ldap/ldap_common.h  |   8 ++
 src/providers/ldap/ldap_init.c    |  11 +++
 src/providers/ldap/sdap_refresh.c | 156 ++++++++++++++++++++++++++++++++++++++
 6 files changed, 196 insertions(+)
 create mode 100644 src/providers/ldap/sdap_refresh.c

diff --git a/Makefile.am b/Makefile.am
index 4cbd4a0b9a669411440b24f90d7daacec74d6386..d19aa61de497b98f52f1b7e750049d24d10b93ac 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1289,6 +1289,7 @@ libsss_ldap_common_la_SOURCES = \
     src/providers/ldap/sdap_idmap.h \
     src/providers/ldap/sdap_range.c \
     src/providers/ldap/sdap_reinit.c \
+    src/providers/ldap/sdap_refresh.c \
     src/providers/ldap/sdap.c
 
 if BUILD_SUDO
diff --git a/src/providers/ad/ad_init.c b/src/providers/ad/ad_init.c
index 2add74a2051d677fb36eb70edb46ddd6bf7e61d9..288921333a2345c14e51eaa6627ecae83b0e7c19 100644
--- a/src/providers/ad/ad_init.c
+++ b/src/providers/ad/ad_init.c
@@ -175,6 +175,16 @@ sssm_ad_id_init(struct be_ctx *bectx,
         goto done;
     }
 
+    /* setup periodical refresh of expired records */
+    ret = be_refresh_add_cb(bectx->refresh_ctx, BE_REFRESH_NETGROUPS,
+                            sdap_refresh_netgroups_send,
+                            sdap_refresh_netgroups_recv,
+                            sdap_ctx);
+    if (ret != EOK && ret != EEXIST) {
+        DEBUG(SSSDBG_MINOR_FAILURE, ("Periodical refresh of netgroups "
+              "will not work [%d]: %s\n", ret, strerror(ret)));
+    }
+
     *ops = &ad_id_ops;
     *pvt_data = ad_ctx;
 
diff --git a/src/providers/ipa/ipa_init.c b/src/providers/ipa/ipa_init.c
index 4be6be64e2a88c1e3c3825949962a14ec11e7484..ac88104b7ab0a9abaf42ebe70809f1fbf0c01f18 100644
--- a/src/providers/ipa/ipa_init.c
+++ b/src/providers/ipa/ipa_init.c
@@ -207,6 +207,16 @@ int sssm_ipa_id_init(struct be_ctx *bectx,
         goto done;
     }
 
+    /* setup periodical refresh of expired records */
+    ret = be_refresh_add_cb(bectx->refresh_ctx, BE_REFRESH_NETGROUPS,
+                            sdap_refresh_netgroups_send,
+                            sdap_refresh_netgroups_recv,
+                            sdap_ctx);
+    if (ret != EOK && ret != EEXIST) {
+        DEBUG(SSSDBG_MINOR_FAILURE, ("Periodical refresh of netgroups "
+              "will not work [%d]: %s\n", ret, strerror(ret)));
+    }
+
     *ops = &ipa_id_ops;
     *pvt_data = ipa_ctx;
     ret = EOK;
diff --git a/src/providers/ldap/ldap_common.h b/src/providers/ldap/ldap_common.h
index 86079fa6ad2aedcf220d38251adc94d60d654bd1..ec2c096eef23d18f0fd3c83fb42ef531b4e1514e 100644
--- a/src/providers/ldap/ldap_common.h
+++ b/src/providers/ldap/ldap_common.h
@@ -235,4 +235,12 @@ sdap_set_sasl_options(struct sdap_options *id_opts,
                       char *default_realm,
                       const char *keytab_path);
 
+struct tevent_req *sdap_refresh_netgroups_send(TALLOC_CTX *mem_ctx,
+                                               struct tevent_context *ev,
+                                               struct be_ctx *be_ctx,
+                                               const char **dn_list,
+                                               void *pvt);
+
+errno_t sdap_refresh_netgroups_recv(struct tevent_req *req);
+
 #endif /* _LDAP_COMMON_H_ */
diff --git a/src/providers/ldap/ldap_init.c b/src/providers/ldap/ldap_init.c
index b8e5ee3aa98e35a4e7ab16c50e0de08103608484..c5c52828f73dab4d368f448b671e0ff718a1f407 100644
--- a/src/providers/ldap/ldap_init.c
+++ b/src/providers/ldap/ldap_init.c
@@ -29,6 +29,7 @@
 #include "providers/ldap/sdap_sudo.h"
 #include "providers/ldap/sdap_autofs.h"
 #include "providers/ldap/sdap_idmap.h"
+#include "providers/dp_refresh.h"
 
 static void sdap_shutdown(struct be_req *req);
 
@@ -172,6 +173,16 @@ int sssm_ldap_id_init(struct be_ctx *bectx,
         goto done;
     }
 
+    /* setup periodical refresh of expired records */
+    ret = be_refresh_add_cb(bectx->refresh_ctx, BE_REFRESH_NETGROUPS,
+                            sdap_refresh_netgroups_send,
+                            sdap_refresh_netgroups_recv,
+                            ctx);
+    if (ret != EOK && ret != EEXIST) {
+        DEBUG(SSSDBG_MINOR_FAILURE, ("Periodical refresh of netgroups "
+              "will not work [%d]: %s\n", ret, strerror(ret)));
+    }
+
     *ops = &sdap_id_ops;
     *pvt_data = ctx;
     ret = EOK;
diff --git a/src/providers/ldap/sdap_refresh.c b/src/providers/ldap/sdap_refresh.c
new file mode 100644
index 0000000000000000000000000000000000000000..67a8411dd756d7fbf00ca9d3a3f18d58b397fdb9
--- /dev/null
+++ b/src/providers/ldap/sdap_refresh.c
@@ -0,0 +1,156 @@
+/*
+    Authors:
+        Pavel Březina <pbrezina@redhat.com>
+
+    Copyright (C) 2013 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <talloc.h>
+#include <tevent.h>
+
+#include "providers/ldap/sdap.h"
+#include "providers/ldap/ldap_common.h"
+
+struct sdap_refresh_netgroups_state {
+    struct tevent_context *ev;
+    struct sdap_id_ctx *id_ctx;
+    const char **name_list;
+    size_t index;
+};
+
+static errno_t sdap_refresh_netgroups_step(struct tevent_req *req);
+static void sdap_refresh_netgroups_done(struct tevent_req *subreq);
+
+struct tevent_req *sdap_refresh_netgroups_send(TALLOC_CTX *mem_ctx,
+                                               struct tevent_context *ev,
+                                               struct be_ctx *be_ctx,
+                                               const char **name_list,
+                                               void *pvt)
+{
+    struct sdap_refresh_netgroups_state *state = NULL;
+    struct tevent_req *req = NULL;
+    errno_t ret;
+
+    req = tevent_req_create(mem_ctx, &state,
+                            struct sdap_refresh_netgroups_state);
+    if (req == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("tevent_req_create() failed\n"));
+        return NULL;
+    }
+
+    state->ev = ev;
+    state->id_ctx = talloc_get_type(pvt, struct sdap_id_ctx);
+    state->name_list = name_list;
+    state->index = 0;
+
+    if (name_list == NULL) {
+        ret = EOK;
+        goto immediately;
+    }
+
+    ret = sdap_refresh_netgroups_step(req);
+    if (ret == EOK) {
+        DEBUG(SSSDBG_TRACE_FUNC, ("Nothing to refresh\n"));
+        goto immediately;
+    } else if (ret != EAGAIN) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("sdap_refresh_netgroups_step() failed "
+                                    "[%d]: %s\n", ret, strerror(ret)));
+        goto immediately;
+    }
+
+    return req;
+
+immediately:
+    if (ret == EOK) {
+        tevent_req_done(req);
+    } else {
+        tevent_req_error(req, ret);
+    }
+    tevent_req_post(req, ev);
+
+    return req;
+}
+
+static errno_t sdap_refresh_netgroups_step(struct tevent_req *req)
+{
+    struct sdap_refresh_netgroups_state *state = NULL;
+    struct tevent_req *subreq = NULL;
+    const char *name = NULL;
+    errno_t ret;
+
+    state = tevent_req_data(req, struct sdap_refresh_netgroups_state);
+
+    if (state->name_list == NULL) {
+        ret = EOK;
+        goto done;
+    }
+
+    name = state->name_list[state->index];
+    if (name == NULL) {
+        ret = EOK;
+        goto done;
+    }
+
+    DEBUG(SSSDBG_TRACE_FUNC, ("Issuing refresh of netgroup %s\n", name));
+
+    subreq = ldap_netgroup_get_send(state, state->ev, state->id_ctx, name);
+    if (subreq == NULL) {
+        ret = ENOMEM;
+        goto done;
+    }
+
+    tevent_req_set_callback(subreq, sdap_refresh_netgroups_done, req);
+
+    state->index++;
+    ret = EAGAIN;
+
+done:
+    return ret;
+}
+
+static void sdap_refresh_netgroups_done(struct tevent_req *subreq)
+{
+    struct tevent_req *req = NULL;
+    errno_t dp_error;
+    errno_t ret;
+
+    req = tevent_req_callback_data(subreq, struct tevent_req);
+
+    ret = ldap_netgroup_get_recv(subreq, &dp_error);
+    talloc_zfree(subreq);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, ("Unable to refresh netgroup [dp_error: %d, "
+              "errno: %d]: %s\n", dp_error, ret, strerror(ret)));
+        goto done;
+    }
+
+    ret = sdap_refresh_netgroups_step(req);
+
+done:
+    if (ret != EOK) {
+        tevent_req_error(req, ret);
+        return;
+    }
+
+    tevent_req_done(req);
+}
+
+errno_t sdap_refresh_netgroups_recv(struct tevent_req *req)
+{
+    TEVENT_REQ_RETURN_ON_ERROR(req);
+
+    return EOK;
+}
-- 
1.7.11.7

